/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-baxter-maintenance-msgs-1.1.1-0precise-20150519-1337/msg/CalibrateArmEnable.msg
 *
 */


#ifndef BAXTER_MAINTENANCE_MSGS_MESSAGE_CALIBRATEARMENABLE_H
#define BAXTER_MAINTENANCE_MSGS_MESSAGE_CALIBRATEARMENABLE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <baxter_maintenance_msgs/CalibrateArmData.h>

namespace baxter_maintenance_msgs
{
template <class ContainerAllocator>
struct CalibrateArmEnable_
{
  typedef CalibrateArmEnable_<ContainerAllocator> Type;

  CalibrateArmEnable_()
    : isEnabled(false)
    , uid()
    , data()  {
    }
  CalibrateArmEnable_(const ContainerAllocator& _alloc)
    : isEnabled(false)
    , uid(_alloc)
    , data(_alloc)  {
    }



   typedef uint8_t _isEnabled_type;
  _isEnabled_type isEnabled;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _uid_type;
  _uid_type uid;

   typedef  ::baxter_maintenance_msgs::CalibrateArmData_<ContainerAllocator>  _data_type;
  _data_type data;




  typedef boost::shared_ptr< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct CalibrateArmEnable_

typedef ::baxter_maintenance_msgs::CalibrateArmEnable_<std::allocator<void> > CalibrateArmEnable;

typedef boost::shared_ptr< ::baxter_maintenance_msgs::CalibrateArmEnable > CalibrateArmEnablePtr;
typedef boost::shared_ptr< ::baxter_maintenance_msgs::CalibrateArmEnable const> CalibrateArmEnableConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace baxter_maintenance_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'baxter_maintenance_msgs': ['/tmp/buildd/ros-hydro-baxter-maintenance-msgs-1.1.1-0precise-20150519-1337/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >
{
  static const char* value()
  {
    return "e29cddd6c5825de42ce8309f5f9cb399";
  }

  static const char* value(const ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xe29cddd6c5825de4ULL;
  static const uint64_t static_value2 = 0x2ce8309f5f9cb399ULL;
};

template<class ContainerAllocator>
struct DataType< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >
{
  static const char* value()
  {
    return "baxter_maintenance_msgs/CalibrateArmEnable";
  }

  static const char* value(const ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bool isEnabled\n\
string uid\n\
CalibrateArmData data\n\
\n\
================================================================================\n\
MSG: baxter_maintenance_msgs/CalibrateArmData\n\
";
  }

  static const char* value(const ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.isEnabled);
      stream.next(m.uid);
      stream.next(m.data);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct CalibrateArmEnable_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::baxter_maintenance_msgs::CalibrateArmEnable_<ContainerAllocator>& v)
  {
    s << indent << "isEnabled: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.isEnabled);
    s << indent << "uid: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.uid);
    s << indent << "data: ";
    s << std::endl;
    Printer< ::baxter_maintenance_msgs::CalibrateArmData_<ContainerAllocator> >::stream(s, indent + "  ", v.data);
  }
};

} // namespace message_operations
} // namespace ros

#endif // BAXTER_MAINTENANCE_MSGS_MESSAGE_CALIBRATEARMENABLE_H
