/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-baxter-maintenance-msgs-1.1.1-0precise-20150519-1337/msg/TareData.msg
 *
 */


#ifndef BAXTER_MAINTENANCE_MSGS_MESSAGE_TAREDATA_H
#define BAXTER_MAINTENANCE_MSGS_MESSAGE_TAREDATA_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace baxter_maintenance_msgs
{
template <class ContainerAllocator>
struct TareData_
{
  typedef TareData_<ContainerAllocator> Type;

  TareData_()
    : tuneGravitySpring(false)  {
    }
  TareData_(const ContainerAllocator& _alloc)
    : tuneGravitySpring(false)  {
    }



   typedef uint8_t _tuneGravitySpring_type;
  _tuneGravitySpring_type tuneGravitySpring;




  typedef boost::shared_ptr< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct TareData_

typedef ::baxter_maintenance_msgs::TareData_<std::allocator<void> > TareData;

typedef boost::shared_ptr< ::baxter_maintenance_msgs::TareData > TareDataPtr;
typedef boost::shared_ptr< ::baxter_maintenance_msgs::TareData const> TareDataConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::baxter_maintenance_msgs::TareData_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace baxter_maintenance_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'baxter_maintenance_msgs': ['/tmp/buildd/ros-hydro-baxter-maintenance-msgs-1.1.1-0precise-20150519-1337/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "241e9c2ceee7da9db50693da0b3f2741";
  }

  static const char* value(const ::baxter_maintenance_msgs::TareData_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x241e9c2ceee7da9dULL;
  static const uint64_t static_value2 = 0xb50693da0b3f2741ULL;
};

template<class ContainerAllocator>
struct DataType< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "baxter_maintenance_msgs/TareData";
  }

  static const char* value(const ::baxter_maintenance_msgs::TareData_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bool tuneGravitySpring\n\
";
  }

  static const char* value(const ::baxter_maintenance_msgs::TareData_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.tuneGravitySpring);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct TareData_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::baxter_maintenance_msgs::TareData_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::baxter_maintenance_msgs::TareData_<ContainerAllocator>& v)
  {
    s << indent << "tuneGravitySpring: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.tuneGravitySpring);
  }
};

} // namespace message_operations
} // namespace ros

#endif // BAXTER_MAINTENANCE_MSGS_MESSAGE_TAREDATA_H
